; English forum: http://purebasic.myforums.net/viewtopic.php?t=6624&highlight=
; Author: TerryHough
; Date: 18. June 2003

CatchImage(0, ?Logo) 
UseImage(0) 

If OpenWindow(1, 0, 0, 200, 100,#PB_Window_ScreenCentered| #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget, "Embedded Image") 
  CreateGadgetList(WindowID()) 
  x = (WindowWidth() - ImageWidth()) / 2 
  y = (WindowHeight() - ImageHeight()) /2 
  ImageGadget(0, x, y, ImageWidth(), ImageHeight(), 0, #PB_Image_Border) 
EndIf 

  SetGadgetState(0, ImageID())  ; Change the picture in the gadget 
   ; ---------------- This is the main processing loop ---------------------- 
  Repeat 
    EventID = WaitWindowEvent() 
      
    ; ------------------- Process the menu events -------------------------- 
    If EventID = #PB_EventMenu 
      Select EventMenuID()     ;  see which menu item was selected 
        Case 1    ; Import 
        Case 5    ; Exit menu chosen 
          Quit = 1  ; Set the exit flag 
      EndSelect 
    EndIf 
      
    ; ------------------ Process the gadget events ------------------------- 
    If EventID = #PB_EventGadget 
      Select EventGadgetID() 
        Case 1    ; Panel gadget chosen 
      EndSelect 
    EndIf    
      
    If EventID =  #WM_CLOSE ;  #PB_EventCloseWindow 
      Quit = 1      
    EndIf 

  ; ------------ Insure changes are saved when quit received --------------- 
  If Quit = 1 
;   Miscellaneous cleanups before closing 
  EndIf  

  Until Quit = 1 
  ; -------------------End of the main processing loop --------------------- 
End 

Logo: IncludeBinary "..\..\Graphics\Gfx\purebasic.bmp" 

; ExecutableFormat=Windows
; FirstLine=1
; EOF