; English forum: 
; Author: Danilo
; Date: 11. November 2002


; Cool Fonts 1, by Danilo - 11.11.2002
;
#FONT_NORMAL    = %00000000
#FONT_BOLD      = %00000001
#FONT_ITALIC    = %00000010
#FONT_UNDERLINE = %00000100
#FONT_STRIKEOUT = %00001000


Procedure CreateFont(Name$,Size,Style)
   If (Style & #FONT_BOLD)      : bold = 700    : EndIf
   If (Style & #FONT_ITALIC)    : italic = 1    : EndIf
   If (Style & #FONT_UNDERLINE) : underline = 1 : EndIf
   If (Style & #FONT_STRIKEOUT) : strikeout = 1 : EndIf
   ProcedureReturn createfont_(Size,0,0,0,bold,italic,underline,strikeout,0,0,0,0,0,Name$)
EndProcedure

Procedure CreateMyImage()
   Normal    = CreateFont("Verdana",48,#FONT_NORMAL)
   Bold      = CreateFont("Verdana",48,#FONT_BOLD)
   Italic    = CreateFont("Verdana",48,#FONT_ITALIC)
   Underline = CreateFont("Verdana",48,#FONT_UNDERLINE)
   StrikeOut = CreateFont("Verdana",48,#FONT_STRIKEOUT)
   Combined1 = CreateFont("Verdana",48,#FONT_BOLD|#FONT_UNDERLINE)
   Combined2 = CreateFont("Verdana",48,#FONT_ITALIC|#FONT_UNDERLINE|#FONT_STRIKEOUT|#FONT_BOLD)
   
   image = CreateImage(1,600,400)
   StartDrawing(ImageOutput())
      DrawingMode(1)
      FrontColor($FF,$FF,$00)
      
      Locate(10,10)
        DrawingFont(Normal)
        DrawText("PureBasic - normal")
      Locate(10,60)
        DrawingFont(Bold)
        DrawText("PureBasic - Bold")
      Locate(10,110)
        DrawingFont(Italic)
        DrawText("PureBasic - Italic")
      Locate(10,160)
        DrawingFont(Underline)
        DrawText("PureBasic - Underline")
      Locate(10,210)
        DrawingFont(StrikeOut)
        DrawText("PureBasic - StrikeOut")
      Locate(10,260)
        DrawingFont(Combined1)
        DrawText("PureBasic - Combined 1")
      Locate(10,310)
        DrawingFont(Combined2)
        DrawText("PureBasic - Combined 2")
   StopDrawing()
   
   DeleteObject_(Normal)   : DeleteObject_(Bold)
   DeleteObject_(Italic)   : DeleteObject_(Underline)
   DeleteObject_(StrikeOut): DeleteObject_(Combined1)
   DeleteObject_(Combined2)

   ProcedureReturn image
EndProcedure

OpenWindow(1,100,200,600,400,#PB_Window_SystemMenu,"Cool Fonts 1")

   myImage = CreateMyImage()

   CreateGadgetList(WindowID())
   ImageGadget(1,0,0,600,400,myImage)

Repeat:Until WaitWindowEvent() = #PB_EventCloseWindow
; ExecutableFormat=Windows
; FirstLine=1
; DisableDebugger
; EOF