; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=2647&highlight=
; Author: Danilo (improved example of PureVampy)
; Date: 24. October 2003


; The StringGadget will become automatically activated, after the window get the focus again
; Das StringGadget wird automatisch aktiviert, nachdem das Fenster den Fokus erhalten hat (aktiviert wurde)

Procedure Open_Window() 
  If OpenWindow(0, 408, 321, 200, 100,  #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered , "Texteingabe") 
    If CreateGadgetList(WindowID()) 
      StringGadget(0, 30, 30, 130, 20, "") 
      ButtonGadget(1,100,60,60,30,"Ok") 
    EndIf 
  EndIf 
EndProcedure 

Procedure MyWindowCallback(WindowID, Message, wParam, lParam) 
  Shared MyWindowCallback_SIZE_RESTORED 
  result = #PB_ProcessPureBasicEvents 
  Select Message 
    Case #WM_SIZE 
      If wParam = #SIZE_RESTORED 
        MyWindowCallback_SIZE_RESTORED = 1 
      EndIf 
    Case #WM_ACTIVATE 
      If MyWindowCallback_SIZE_RESTORED = 1 
        ActivateGadget(0) 
        MyWindowCallback_SIZE_RESTORED = 0 
        result = 0 
      EndIf 
  EndSelect 
  ProcedureReturn result 
EndProcedure 

Open_Window() 

SetWindowCallback(@MyWindowCallback()) 

Repeat 
  ;ActivateGadget(0)     => hier wird der Fokus zwar richtig gesetzt, aber der Button ignoriert! 
  Event = WaitWindowEvent() 
  If Event = #PB_EventGadget 
   GadgetID = EventGadgetID() 
   If GadgetID = 0 
    ;Code 
   EndIf 
  EndIf 
Until Event = #PB_EventCloseWindow 

End 

; ExecutableFormat=Windows
; EnableXP
; EOF