; English forum: http://purebasic.myforums.net/viewtopic.php?t=8166&highlight=
; Author: Berikco
; Date: 02. November 2003


; PureBasic Visual Designer v3.80 build 1284 


;- Window Constants 
; 
Enumeration 
  #Window_0 
EndEnumeration 

;- Gadget Constants 
; 
Enumeration 
  #Button_0 
EndEnumeration 


; BalloonTip Constants 
#TOOLTIP_NO_ICON      = 0 
#TOOLTIP_INFO_ICON    = 1 
#TOOLTIP_WARNING_ICON = 2 
#TOOLTIP_ERROR_ICON   = 3 

Procedure BalloonTip(WindowID, Gadget, Text$ , Title$, Icon) 
  
  ToolTip=CreateWindowEx_(0,"ToolTips_Class32","",#WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON,0,0,0,0,WindowID,0,GetModuleHandle_(0),0) 
  SendMessage_(ToolTip,#TTM_SETTIPTEXTCOLOR,GetSysColor_(#COLOR_INFOTEXT),0) 
  SendMessage_(ToolTip,#TTM_SETTIPBKCOLOR,GetSysColor_(#COLOR_INFOBK),0) 
  SendMessage_(ToolTip,#TTM_SETMAXTIPWIDTH,0,180) 
  Balloon.TOOLINFO\cbSize=SizeOf(TOOLINFO) 
  Balloon\uFlags=#TTF_IDISHWND | #TTF_SUBCLASS 
  Balloon\hWnd=GadgetID(Gadget) 
  Balloon\uId=GadgetID(Gadget) 
  Balloon\lpszText=@Text$ 
  SendMessage_(ToolTip, #TTM_ADDTOOL, 0, Balloon) 
  If Title$ > "" 
    SendMessage_(ToolTip, #TTM_SETTITLE, Icon, @Title$) 
  EndIf 
  
EndProcedure 

Procedure Open_Window_0() 
  If OpenWindow(#Window_0, 216, 0, 600, 300,  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar , "New window ( 0 )") 
    If CreateGadgetList(WindowID()) 
      ButtonGadget(#Button_0, 48, 64, 136, 40, "Ok") 
      BalloonTip(WindowID(), #Button_0, "Tooltip", "Balloon title", #TOOLTIP_ERROR_ICON) 
      
    EndIf 
  EndIf 
EndProcedure 
Open_Window_0() 

Repeat 
  
  Event = WaitWindowEvent() 
  
  If Event = #PB_EventGadget 
    
    ;Debug "WindowID: " + Str(EventWindowID()) 
    
    GadgetID = EventGadgetID() 
    
    If GadgetID = #Button_0 
      Debug "GadgetID: #Button_0" 
      
    EndIf 
    
  EndIf 
  
Until Event = #PB_EventCloseWindow 

End 
;
; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; EOF