; English forum: 
; Author: Justin
; Date: 28th February 2003


;Draw bitmap setting a transparent color
;Ref : http://msdn.microsoft.com/library/en-us/shellcc/platform/commctls/imagelist/reflist.asp

;this example draws a 200x200 256 colors bitmap at 0,0 coord in the window
;black (0,0,0) is set as the transparent color
;change the includebinary with your own bitmap (200x200 256 color)

;Justin 02/03

;structure
ptst.PAINTSTRUCT

Global ptst,himglist

;CREATE IMAGE LIST 
;200x200 imglist 256 colors, 1 img
;transparent=black 

; hbimglist=CatchImage(0,?limglist)
hbimglist = LoadImage(0, "..\gfx\pb.bmp")

himglist=ImageList_Create_(200,200,#ILC_COLOR8|#ILC_MASK,1,0)
ImageList_AddMasked_(himglist,hbimglist,RGB(0,0,0)) ;set transparent color

;window procedure
Procedure windowproc(hwnd,msg,wparam,lparam)
  retval=#PB_ProcessPureBasicEvents 
  Select msg
    Case #WM_PAINT ;DRAW IMAGE
      hdc=BeginPaint_(hwnd,@ptst)
      ImageList_Draw_(himglist,0,hdc,0,0,#ILD_TRANSPARENT) 
      EndPaint_(hwnd,@ptst)
      retval=0
  
  EndSelect
  ProcedureReturn retval
EndProcedure

;WINDOW
OpenWindow(0,150,70,552,352,#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar,"Window1")

SetWindowCallback(@windowproc()) 

;EVENT LOOP
Repeat
Until WaitWindowEvent()=#PB_EventCloseWindow

;free imglist
ImageList_Destroy_(himglist)
End

;limglist : IncludeBinary "yourimage.bmp"
; ExecutableFormat=Windows
; FirstLine=1
; EOF