; English forum: http://purebasic.myforums.net/viewtopic.php?t=8736&highlight=
; Author: Danilo (updated for PB3.93 by ts-soft)
; Date: 14. December 2003

; 
; Bitmap Bits Test 
; Danilo, 10.04.2003 

Structure myBITMAPINFO 
  bmiHeader.BITMAPINFOHEADER 
  bmiColors.RGBQUAD[1] 
EndStructure 

hBmp = CreateImage(1,300,100) 
hDC  = StartDrawing(ImageOutput()) 
  ImageWidth  = ImageWidth() 
  ImageHeight = ImageHeight() 
  mem = AllocateMemory(ImageWidth*ImageHeight*4) 
  bmi.myBITMAPINFO 
  bmi\bmiHeader\biSize   = SizeOf(BITMAPINFOHEADER) 
  bmi\bmiHeader\biWidth  = ImageWidth 
  bmi\bmiHeader\biHeight = ImageHeight 
  bmi\bmiHeader\biPlanes = 1 
  bmi\bmiHeader\biBitCount = 32 
  bmi\bmiHeader\biCompression = #BI_RGB 
  If GetDIBits_(hDC,hBmp,0,ImageHeight(),mem,bmi,#DIB_RGB_COLORS) <> 0 
    ; Fill 
    *pixels.LONG = mem 
    For a = 1 To ImageWidth*(ImageHeight/3) 
      *pixels\l = $FFFF00 
      *pixels + 4 
    Next a 
    
    ; Copy back 
    If SetDIBits_(hDC,hBmp,0,ImageHeight(),mem,bmi,#DIB_RGB_COLORS) <> 0 
      StopDrawing() 
      OpenWindow(0,0,0,ImageWidth,ImageHeight,#PB_Window_ScreenCentered|#PB_Window_SystemMenu,"Image") 
        CreateGadgetList(WindowID()) 
        ButtonImageGadget(0,0,0,ImageWidth,ImageHeight,hBmp) 
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow 
    Else 
      StopDrawing() 
    EndIf 
  EndIf
  
; ExecutableFormat=Windows
; FirstLine=1
; DisableDebugger
; EOF