; English forum: http://purebasic.myforums.net/viewtopic.php?t=9182&highlight=
; Author: Danilo
; Date: 17. January 2004

Procedure ResizeImage_NoAntialias(image,w,h) 
  ; 
  ; resize PB image without antialiasing 
  ; 
  ; by Danilo, 17.01.2004 - english forum 
  ; 
  hBmp_orig = UseImage(image) 
  width    = ImageWidth() 
  height   = ImageHeight() 
  hDesk = GetDesktopWindow_() 
  hDC_orig = GetWindowDC_(hDesk) 
  If hDC_orig 
    hDC = CreateCompatibleDC_(hDC1) 
    If hDC 
      hBmp = CreateCompatibleBitmap_(hDC_orig,width,height) 
      If hBmp 
        SelectObject_(hDC,hBmp) 
        hDC_orig = StartDrawing(ImageOutput()) 
        If hDC_orig 
          BitBlt_(hDC,0,0,width,height,hDC_orig,0,0,#SRCCOPY) 
          StopDrawing() 
          hBmp_orig = CreateImage(image,w,h) 
          hDC_orig  = StartDrawing(ImageOutput()) 
          If hDC_orig 
            StretchBlt_(hDC_orig,0,0,w,h,hDC,0,0,width,height,#SRCCOPY) 
            StopDrawing() 
            result = #TRUE 
          EndIf 
        EndIf 
        DeleteObject_(hBmp) 
      EndIf 
      DeleteDC_(hDC) 
    EndIf 
    ReleaseDC_(hDesk,hDC_orig) 
  EndIf 
  ProcedureReturn result 
EndProcedure 

CreateImage(1,50,50) 
  StartDrawing(ImageOutput()) 
    For a = 0 To 10000:Plot(Random(50),Random(50),Random($FFFFFF)):Next a 
  StopDrawing() 

CopyImage(1,2) 

ResizeImage_NoAntialias(2,450,450) 

OpenWindow(0,0,0,500,500,#PB_Window_SystemMenu,"ResizeImage") 
  CreateGadgetList(WindowID()) 
  ImageGadget(0, 0, 0, 50, 50,UseImage(1)) 
  ImageGadget(1,50,50,450,450,UseImage(2)) 
Repeat:Until WaitWindowEvent()=#PB_Event_CloseWindow 

; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; DisableDebugger
; EOF