; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=2636&highlight=
; Author: ChaOsKid
; Date: 23. October 2003

; Mirror a sprite, use Return or Space to see the effect, Esc for quit
; Spiegeln eines Sprites, benutze Return oder Space zum Ansehen des Effekts, Esc fr Abbruch

; Die Funktion StretchBlt kopiert eine Bitmap aus einem Speicher-Gertekontext in einen
; anderen Gertekontext, wobei die Hhe und die Breite von Quell- und Zielbereich sich
; unterscheiden knnen und dadurch Vergerungen und Verkleinerungen ebenso mglich werden
; wie Verzerrungen oder Spiegelungen um die horizonale und/oder vertikale Achse. Alle
; Koordinaten- und Grenangaben werden in Pixeln angegeben.

Breite.l = GetSystemMetrics_(#SM_CXSCREEN) 
Hoehe.l = GetSystemMetrics_(#SM_CYSCREEN) 
hdc.l = GetDC_(0) 
Tiefe.l = GetDeviceCaps_(hdc, #BITSPIXEL) 
ReleaseDC_(0, hdc) 
If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenScreen(Breite, Hoehe, Tiefe, "") = 0 
  End 
EndIf 

Procedure MirrorSprite(SpriteID.l, Direction.l) 
  hdc = StartDrawing(SpriteOutput(SpriteID)) 
    Height = SpriteHeight(SpriteID) 
    Width = SpriteWidth(SpriteID) 
    If Direction 
      StretchBlt_(hdc, 0, Height, Width, -Height, hdc, 0, 0, Width, Height, #SRCCOPY) 
    Else 
      StretchBlt_(hdc, Width, 0, -Width, Height, hdc, 0, 0, Width, Height, #SRCCOPY) 
    EndIf 
  StopDrawing() 
EndProcedure 

Width = 100 
Height = 30 
CreateSprite(0,Width,Height) 
StartDrawing(SpriteOutput(SpriteID)) 
  DrawingMode(1) 
  FrontColor(255, 255, 255) 
  DrawText("1234567890") 
StopDrawing() 
  
Repeat 
  ClearScreen(0,0,0) 
  ; Tastaturabfrage 
  If ExamineKeyboard() 
    If KeyboardPushed(#PB_Key_Escape) 
      Quit = 1 
    EndIf 
    If KeyboardReleased(#PB_Key_Space) 
      MirrorSprite(0, 0) 
    EndIf 
    If KeyboardReleased(#PB_Key_Return) 
      MirrorSprite(0, 1) 
    EndIf 
  EndIf 
  DisplayTransparentSprite(0, Breite/2-50, Hoehe/2-25) 
  FlipBuffers() 
Until Quit > 0
; ExecutableFormat=Windows
; EOF