; www.purearea.net
; Author: Andre (based on NicTheQuick event loop)
; Date: 23. August 2003

If OpenWindow(0,0,0,300,200,#PB_Window_SystemMenu|#PB_Window_ScreenCentered,"Event handling example...")
  If CreateGadgetList(WindowID())
    ButtonGadget(1, 10, 10,200, 20, "Button 1")
    ButtonGadget(2, 10, 40,200, 20, "Button 2")
    ButtonGadget(3, 10, 70,200, 20, "Button 3")
    StringGadget(4, 10,100,200, 20, "String....")
  EndIf
  If CreateMenu(0, WindowID())
    MenuTitle("Menu")
    MenuItem(1, "Item 1")
    MenuItem(2, "Item 2")
    MenuItem(3, "Item 3")
  EndIf
  Repeat
    EventID.l = WaitWindowEvent()
    Select EventID
    Case #PB_EventCloseWindow
      End
    Case #PB_EventGadget
      Select EventGadgetID()
      Case 1 : Debug "Button 1 clicked!"
      Case 2 : Debug "Button 2 clicked!"
      Case 3 : Debug "Button 3 clicked!"
      EndSelect
    Case #PB_EventMenu
      Select EventMenuID()
      Case 1 : Debug "Menu item 1 clicked!"
      Case 2 : Debug "Menu item 2 clicked!"
      Case 3 : Debug "Menu item 3 clicked!"
      EndSelect
    Case #WM_KEYFIRST
      Select EventwParam()
      Case #VK_RETURN : Debug "Return in Gadget " + Str(EventGadgetID()) + " - Entered text: "+GetGadgetText(EventGadgetID())
      Case #VK_ESCAPE : Debug "Escape in Gadget " + Str(EventGadgetID())
        ; Case #VK_...    ; hier weitere Tastaturabfragen einfgen...
      EndSelect
    EndSelect
  ForEver
EndIf

; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; EOF