; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=2133&highlight=
; Author: The_Pharao
; Date: 29. August 2003


; Example for saving array contents before ReDim'ing it and using the content again 


;*** Erstellt: 29. August 2003 *** 

;*** Die Funktion "RedimPreserveSave" speichert den Inhalt eines Arrays *** 
;*** in den Puffer RedimPuffer                                 *** 

Dim RedimPuffer.b(0) 
RedimPufferSize.l = 1 

Procedure RedimPreserveSave(PtrToArray.l, LengthOfArray.l) 

  Shared RedimPufferSize.l 
  Dim RedimPuffer.b(LengthOfArray) 
    
  CopyMemory(PtrToArray, @RedimPuffer(), LengthOfArray) 

  RedimPufferSize = LengthOfArray 
EndProcedure 

;*** Die Funktion "RedimPreserveRestore" speichert den Inhalt des Puffer*** 
;*** in das Array zurck und bercksichtigt dabei die Lnge             *** 

Procedure RedimPreserveRestore(PtrToArray.l, LengthOfArray.l) 

Shared RedimPufferSize.l 

  If LengthOfArray > RedimPufferSize 
  
    CopyMemory(@RedimPuffer(), PtrToArray, RedimPufferSize) 
    
  Else 
  
    CopyMemory(@RedimPuffer(), PtrToArray, LengthOfArray) 
    
  EndIf 

EndProcedure 


; *** Hier wird getestet, ob es auch funktioniert 

; *** Definieren einer Struktur: 

Structure strctPosition 
  X.f 
  Y.f 
EndStructure 
Structure strctShip 
  Pos.strctPosition 
  Name.s[10] 
EndStructure 

; *** Erzeugen unseres Arrays, das spter "Preserved" (d.h. geschtzt) re-dimensioniert werden soll 



Dim Ship.strctShip(5) 

ShipCount = 6 ; 0,1,2,3,4,5 

For k = 0 To 5 

  Ship(k)\Pos\x = 100 + k ; Jedem Schiff eine X-Position zuweisen 


Next k 

; Hier wird die Array-Information zwischengespeichert 
RedimPreserveSave (@Ship(0), SizeOf(strctShip) * ShipCount) 

;Array neu dimensionieren 
ShipCount = 10 
Dim Ship.strctShip(ShipCount - 1) 
;Jetzt ist das Array zurckgesetzt, d.h. die X-Position, 
;die oben festgelegt wurde, ist verloren! 


;Aber zum Glck haben wir die ja zwischengespeichert ;) 
RedimPreserveRestore(@Ship(0), SizeOf(strctShip) * ShipCount) 

;Die X-Position der Schiffe 0-5 ist also wieder da, 
;die Schiffe 6-Obergrenze sind natrlich leer. 

For k = 0 To ShipCount-1 

  MessageRequester ("X-Position von Ship #" + Str(k) , Str(Ship(k)\Pos\X), 0) 

Next k 

;The End! 

End 

; ExecutableFormat=Windows
; FirstLine=1
; EOF