; German forum: 
; Author: NicTheQuick
; Date: 26. April 2003
; OS: Windows
; Demo: No

Procedure.s OpenBeschrWindow(Text.s, ProcName.s) 
  Protected BWidth.l, BHeight.l, Quit.l, OffsetY.l, TmpText.s 
  
  TmpText = Text 
  EnableWindow_(WindowID(0), #False) 

  BWidth = 350 
  BHeight = 300 
  #BButtonHeight = 20 
  If OpenWindow(1, 0, 0, BWidth, BHeight, #PB_Window_Systemmenu | #PB_Window_SizeGadget | #PB_Window_MinimizeGadget | #PB_Window_WindowCentered, "Beschreibung - " + Chr(34) + ProcName + Chr(34)) 
    If CreateGadgetList(WindowID()) 
      StringGadget(100, 5, 5, BWidth - 10, BHeight - #BButtonHeight - 15, Text, #PB_String_Multiline | #WS_VSCROLL | #WS_HSCROLL) 
      OffsetY = BHeight - #BButtonHeight - 5 
      ButtonGadget(101, 5, OffsetY, (BWidth - 15) / 2, #BButtonHeight, "OK", #PB_Button_Default) 
      ButtonGadget(102, 5 + (BWidth - 10 + 5) / 2, OffsetY, (BWidth - 15) / 2, #BButtonHeight, "Abbrechen") 
    EndIf 
    
    ActivateGadget(100) 
    
    Quit = #False 
    Repeat 
      If WindowWidth() <> BWidth Or WindowHeight() <> BHeight 
        BWidth = WindowWidth() 
        BHeight = WindowHeight() 
        ResizeGadget(100, -1, -1, BWidth - 10, BHeight - #BButtonHeight - 15) 
        OffsetY = BHeight - #BButtonHeight - 5 
        ResizeGadget(101, -1, OffsetY, (BWidth - 15) / 2, #BButtonHeight) 
        ResizeGadget(102, 5 + (BWidth - 10 + 5) / 2, OffsetY, (BWidth - 15) / 2, #BButtonHeight) 
      EndIf 
      
      EventID.l = WaitWindowEvent() 
      Select EventID 
        Case #PB_EventCloseWindow 
          Quit = #True 
        
        Case #PB_EventGadget 
          Select EventGadgetID() 
            Case 101 
              Quit = #True 
              Text = GetGadgetText(100) 
            Case 102 
              Quit = #True 
              Text = TmpText 
          EndSelect 
      EndSelect 
    Until Quit 
    
    UseGadgetList(WindowID(0)) 
    UseWindow(0) 
    CloseWindow(1) 
    EnableWindow_(WindowID(0), #True) 
    ActivateWindow() 
  EndIf 

  ProcedureReturn Text 

EndProcedure 

If OpenWindow(0, 0, 0, 400, 300, #PB_Window_Systemmenu | #PB_Window_ScreenCentered, "MainWindow") 
  If CreateMenu(0, WindowID()) 
    MenuTitle("Datei") 
    MenuItem(1, "ffnen") 
  EndIf 
  
  Repeat 
    EventID.l = WaitWindowEvent() 
    Select EventID 
      Case #PB_EventCloseWindow 
        End 
      Case #PB_EventMenu 
        Select EventMenuID() 
          Case 1: OpenBeschrWindow("Test... 1, 2, 3", "Test-Procedure") 
        EndSelect 
    EndSelect 
  ForEver 
EndIf
; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; DisableDebugger
; EOF