; English forum: http://purebasic.myforums.net/viewtopic.php?t=8479&highlight=
; Author: Kale
; Date: 28. November 2003

;=========================================================================== 
;-PROCEDURES 
;=========================================================================== 

;Window callback 
Procedure WindowCallback(hWnd, Message, wParam, lParam) 
    Select Message 
        Case #WM_CLOSE 
            UnregisterClass_("WindowClass", GetModuleHandle_(#NULL)) 
            Destroywindow_(hWnd) 
            ProcedureReturn 0 
        Case #WM_DESTROY 
            UnregisterClass_("WindowClass", GetModuleHandle_(#NULL)) 
            PostQuitMessage_(0) 
            ProcedureReturn 0 
    EndSelect 
    Result = DefWindowProc_(hWnd, Message, wParam, lParam) 
    ProcedureReturn Result 
EndProcedure 

;Window class 
WindowClass.WNDCLASS 
Classname.s = "WindowClass" 
WindowClass\style = #CS_HREDRAW | #CS_VREDRAW 
WindowClass\lpfnWndProc = @WindowCallback() 
WindowClass\cbClsExtra = 0 
WindowClass\cbWndExtra = 0 
WindowClass\hInstance = GetModuleHandle_(#NULL) 
WindowClass\hIcon = LoadIcon_(#NULL, #IDI_APPLICATION) 
WindowClass\hCursor = LoadCursor_(#NULL, #IDC_ARROW) 
WindowClass\hbrBackground = GetStockObject_(#WHITE_BRUSH) 
WindowClass\lpszMenuName = #NULL 
WindowClass\lpszClassName = @Classname 
RegisterClass_(WindowClass) 

;=========================================================================== 
;-GEOMETRY 
;=========================================================================== 

;Calculate the window position to display it centrally 
ScreenWidth.l = GetSystemMetrics_(#SM_CXSCREEN) 
ScreenHeight.l = GetSystemMetrics_(#SM_CYSCREEN) 
WindowWidth.l = 406 
WindowHeight.l = 322 
WindowXPosition.l = (ScreenWidth / 2) - (WindowWidth / 2) 
WindowYPosition.l = (ScreenHeight/ 2) - (WindowHeight/ 2) 

hWnd.l = CreateWindowEx_(#WS_EX_TOOLWINDOW, "WindowClass", "Text Window...", #WS_VISIBLE | #WS_OVERLAPPEDWINDOW | #WS_SIZEBOX , WindowXPosition, WindowYPosition, WindowWidth, WindowHeight, 0, 0, GetModuleHandle_(#NULL), 0) 

CreateGadgetList(hWnd) 
    StringGadget(1, 10, 10, 380, 280, "", #PB_String_Multiline | #PB_String_ReadOnly | #ES_AUTOVSCROLL | #WS_VSCROLL | #ESB_DISABLE_LEFT | #ESB_DISABLE_RIGHT) 
    SetGadgetText(1, "Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Proin vestibulum consequat felis. Pellentesque wisi sem, mattis ut, sagittis et, gravida id, wisi. Donec nulla.") 

;=========================================================================== 
;-MAIN LOOP 
;=========================================================================== 

If hWnd 
    While Getmessage_(Message.MSG, 0, 0, 0) 
        TranslateMessage_(Message) 
        DispatchMessage_(Message) 
    Wend 
EndIf
; ExecutableFormat=Windows
; EnableXP
; EOF