; English forum: http://purebasic.myforums.net/viewtopic.php?t=6585&highlight=
; Author: Freak
; Date: 16. June 2003

; But be aware that if you have many big files then the total size may be 
; reported incorrectly due to limitations (missing big numbers) in PureBasic... 

Procedure.l DirectorySize(ID.l, Directory.s) 
  Protected Size.l 
  If ExamineDirectory(ID, Directory, "*.*") 
    Repeat 
      Entry.l = NextDirectoryEntry() 
      If Entry = 1 
        Size + DirectoryEntrySize() 
      ElseIf Entry = 2 
        Name.s = DirectoryEntryName() 
        If Name <> ".." And Name <> "." 
          Size + DirectorySize(ID+1, Directory+Name+"\") 
          UseDirectory(ID) 
        EndIf 
      EndIf 
    Until Entry = 0 
  EndIf 
  ProcedureReturn Size 
EndProcedure 

; Use 0 as ID, it is only needed for the recursive calls 
Debug DirectorySize(0, "C:\WINNT\") 
Debug DirectorySize(0, "C:\Windows\") 

; ExecutableFormat=Windows
; FirstLine=1
; EOF