; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=3003&start=10
; Author: Sylvia (updated for PB3.92+ by Lars)
; Date: 06. December 2003

; Compares two files, their path given as parameter
; Vergleicht zwei Dateien, deren Pfade werden als Parameter bergeben

; *********************************** 
; * 06.Dec.2003 "Sylvia" German Forum 
; *********************************** 

Procedure FileCompare(Pfad1$,Pfad2$) 
     ; Inhaltsvergleich zweier Dateien 
     ; Result<0        Es ist ein Fehler aufgetreten 
     ; Result=0        Dateien sind ungleich 
     ; Result=1        Dateien sind gleich 
      
     Protected LOF1, LOF2, Count, Result, KSize 
      
     KSize=1024*32   ; FileRead-Size in KB 
      
     ; Dateien nicht vorhanden oder unterschiedlich gross ? 
     LOF1=FileSize(Pfad1$): If LOF1<0: ProcedureReturn -1: EndIf 
     LOF2=FileSize(Pfad2$): If LOF2<0: ProcedureReturn -1: EndIf 
      
     If LOF1<>LOF2: ProcedureReturn 0: EndIf 
      
     If ReadFile(101,Pfad1$)=0: Result=-1: Goto FileCompareEnd: EndIf 
     If ReadFile(102,Pfad2$)=0: Result=-1: Goto FileCompareEnd: EndIf 
      
     ; vorbereiten zum Vergleich 
     *Buffer1=AllocateMemory(KSize): If *Buffer1=0: Result=-1: Goto FileCompareEnd: EndIf 
     *Buffer2=AllocateMemory(KSize): If *Buffer2=0: Result=-1: Goto FileCompareEnd: EndIf 
     CopyMemory(*Buffer1,*Buffer2,KSize) 
      
     Result=1 
     Count=0 
      
     ; Vergleich Byte by Byte in KSize-Blcken 
     While LOF1>Count 
          If (LOF1-Count)>KSize 
               UseFile(101): FileSeek(Count): ReadData(*Buffer1,KSize) 
               UseFile(102): FileSeek(Count): ReadData(*Buffer2,KSize) 
               Count+KSize 
          Else 
               UseFile(101): FileSeek(Count): ReadData(*Buffer1,LOF1-Count) 
               UseFile(102): FileSeek(Count): ReadData(*Buffer2,LOF1-Count) 
               Count=LOF1 
          EndIf 
          
          If CompareMemory(*Buffer1,*Buffer2,KSize)=0 
               Result=0 
               Count=LOF1 
          EndIf 
     Wend 
      
     FileCompareEnd: 
     CloseFile(101) : CloseFile(102) 
     FreeMemory(*Buffer1): FreeMemory(*Buffer2) 
      
     ProcedureReturn Result 
EndProcedure    

Debug FileCompare("a.txt","b.txt")

; ExecutableFormat=Windows
; FirstLine=1
; EOF