; German forum:
; Author: CyberRun8 
; Date: 03. April 2003

;Beispiel von CyberRun8 
;fr PureBasic 3.62 
;Mrz 2003 

;-Konstanten setzen 
#Window = 0 

#Gadget1 = 0 
#Gadget2 = 1 
#Gadget3 = 2 

;-Fenster mit Gadgets darstellen 
If OpenWindow(#Window, 100, 150, 240, 90, #PB_Window_MinimizeGadget, "AdvancedGadgetEvents") 
  If CreateGadgetList(WindowID()) 
    AdvancedGadgetEvents(#True) ; <---- 
    ButtonGadget(#Gadget1, 5, 5, 230, 20, "Doppelklick-Button") 
    ButtonGadget(#Gadget2, 5, 35, 230, 20, "Einfachklick-Button") 
    AdvancedGadgetEvents(#False); <---- 
    ButtonGadget(#Gadget3, 5, 65, 230, 20, "Gadget ohne Advanced-Funktion") 
  EndIf 
EndIf 

Debug "Focusangabe:" 
;-Schleife 
Repeat 
  EventID.l = WaitWindowEvent() 
  
  If EventID = #PB_EventGadget    
    Select EventGadgetID() 
      Case #Gadget1 
        If EventType() = #PB_EventType_Focus 
          Debug "Focus auf Doppelklick-Button gesetzt"                
        ElseIf EventType() = #PB_EventType_LeftDoubleClick 
          MessageRequester("Info", "Linksdoppelklick", 0) 
        ElseIf EventType() = #PB_EventType_RightDoubleClick 
          MessageRequester("Info", "Rechtsdoppelklick", 0)              
        EndIf 
      Case #Gadget2 
        If EventType() = #PB_EventType_LeftClick          
          MessageRequester("Info", "Linksklick auf Einfachklick-Button", 0) 
        ElseIf EventType() = #PB_EventType_RightClick          
          MessageRequester("Info", "Rechtsklick auf Einfachklick-Button", 0) 
        ElseIf EventType() = #PB_EventType_Focus 
          Debug "Focus auf Einfachklick-Button gesetzt" 
        EndIf 
      Case #Gadget3 
        ;Folgende Abfrage ist ohne Funkton weil fr Gadget3 die fortgeschrittene Ereignisangabe 
        ;abgeschaltet wurde. 
        If EventType() = #PB_EventType_Focus 
          Debug "Focus auf Doppelklick-Button gesetzt"                
        ElseIf EventType() = #PB_EventType_LeftDoubleClick 
          MessageRequester("Info", "Linksdoppelklick", 0) 
        ElseIf EventType() = #PB_EventType_RightDoubleClick 
          MessageRequester("Info", "Rechtsdoppelklick", 0)              
        EndIf          
    EndSelect 
  EndIf        
Until EventID = #PB_EventCloseWindow 
End
; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; EOF