; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=1334&highlight=
; Author: Andreas
; Date: 13. June 2003


; Code example for automatic resizing window with SplitterGadget, PanelGadget etc.

#Window           = 1 
#Panel            = 2 
#Button1          = 3 
#List1            = 4 
#List2            = 5 
#Splitter1        = 6 
#Splitter2        = 7 

Procedure Resize() 
    ShowWindow_(UseWindow(#Window), #SW_MAXIMIZE) 
EndProcedure 

Global Quit.l 
Event.l 

Procedure WCB(wnd, msg, wParam, lParam) 
    Result = #PB_ProcessPureBasicEvents 
    Select msg 
    Case #WM_SIZE 
        ResizeGadget(#Panel, -1, -1, WindowWidth(), WindowHeight()) 
        ResizeGadget(#Splitter1, -1, -1, WindowWidth() / 2, WindowHeight() / 2) 
        ResizeGadget(#Splitter2, -1, -1, WindowWidth(), WindowHeight() - 40) 
        SetGadgetState(#Splitter1, 100) 
        SetGadgetState(#Splitter2, 100) 
    EndSelect 
    ProcedureReturn Result 
EndProcedure 

OpenWindow(#Window,0,0,320,240,#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget,"Window#0") 
CreateGadgetList(WindowID(#Window)) 
PanelGadget(#Panel, 0, 0, WindowWidth(), WindowHeight()) 
AddGadgetItem(#Panel, -1, "Test") 
ButtonGadget(#Button1, #Null, #Null, #Null, #Null, "Hello") 
ListIconGadget(#List1, #Null, #Null, #Null, #Null, "Hello2", 120) 
EditorGadget(#List2, #Null, #Null, #Null, #Null, "Hello3") 

SplitterGadget(#Splitter1, 40, 40, WindowWidth() / 2, WindowHeight() / 2, #List1, #List2) 
SplitterGadget(#Splitter2, 0, 40, WindowWidth(), WindowHeight() - 40, #Button1, #Splitter1,#PB_Splitter_Vertical) 
CloseGadgetList() 

MessageRequester("Info", "Bitte einen Moment warten, nach dem OK!", #PB_MessageRequester_Ok) 

For i.l = 1 To 1230 
    AddGadgetItem(#List1, -1, "blb") 
Next i 

For i.l = 1 To 512 
    Temp.s = "" 
    For x.l = 1 To 512 
        Temp = Temp + Chr(Random(128)) 
    Next x 
    AddGadgetItem(#List2, -1, Temp) 
Next i 

MessageRequester("Info", "Zum Resizen bitte auf den Schalter Hello klicken!", #PB_MessageRequester_Ok) 
SetWindowCallback(@wcb()) 

Repeat 
    
    Event = WaitWindowEvent() 
    
    Select Event 
    Case #PB_EventGadget 
        
        Select EventGadgetID() 
        Case #Button1 
            Resize() 
            
        EndSelect 
        
    Case #PB_EventCloseWindow 
        Quit = #True 
        
    EndSelect 
    
Until Quit 
End 

; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; EOF