; English forum: http://purebasic.myforums.net/viewtopic.php?t=8801&highlight=
; Author: DriakTravo
; Date: 20. December 2003

; Press left mousebutton to shot into direction of mouse-cursor, right mousebutton to exit...

InitSprite() 
InitMouse() 

OpenScreen(800,600,32,"") 

Structure bullet 
  X.f 
  Y.f 
  XS.f 
  YS.f 
EndStructure 

NewList bullets.bullet() 

Procedure Addbullet(X.f,Y.f,XS.f,YS.f) 
  AddElement(Bullets()) 
  Bullets()\X = X 
  Bullets()\Y = Y 
  Bullets()\XS = XS 
  Bullets()\YS = YS 
EndProcedure 

Global mouseangle, BulletSpeed 
BulletSpeed = 20 

Procedure.f GetMouseAngle() 
  ExamineMouse() 
  x1 = 400 
  y1 = 300 
  x2 = MouseX() 
  y2 = MouseY() 
  a.f = x2-x1 
  b.f = y2-y1 
  c.f = Sqr(a*a+b*b) 
  winkel.f = ACos(a/c)*57.29577 
  If y1 < y2 : winkel=360-winkel : EndIf 
  ProcedureReturn winkel+90 
EndProcedure 

Repeat 
  ClearScreen(0,0,0) 
  ExamineMouse() 
  
  If CountList(bullets()) > 1 
    ResetList(Bullets()) 
    While NextElement(Bullets()) 
      StartDrawing(ScreenOutput()) 
        Line(Bullets()\X,Bullets()\Y,Bullets()\XS,Bullets()\YS,RGB(Random(150),Random(255),0)) 
      StopDrawing() 
      Bullets()\X + Bullets()\XS 
      Bullets()\Y + Bullets()\YS 
      If Bullets()\X > 800 + Bullets()\XS 
        DeleteElement(Bullets()) 
      EndIf 
      If Bullets()\X < 0 - Bullets()\XS 
        DeleteElement(Bullets()) 
      EndIf 
      If Bullets()\Y > 600 + Bullets()\YS 
        DeleteElement(Bullets()) 
      EndIf 
      If Bullets()\Y < 0 - Bullets()\YS 
        DeleteElement(Bullets()) 
      EndIf 
    Wend 
  EndIf 
  
  StartDrawing(ScreenOutput()) 
    Circle(MouseX(),MouseY(),2,RGB(0,255,255)) 
  StopDrawing() 
  
  If MouseButton(2) = 1 
    End 
  ElseIf MouseButton(1) = 1 
    Angle.f = GetMouseAngle() 
    SpeedX.f = Sin(Angle*(3.14/180))*Bulletspeed 
    SpeedY.f = Cos(Angle*(3.14/180))*Bulletspeed 
    dudecounter + 1 
    If dudecounter = 10 
      dudecounter = 0 
      Addbullet(400,300,SpeedX,SpeedY) 
      Angle.f = GetMouseAngle()+10 
      SpeedX.f = Sin(Angle*(3.14/180))*Bulletspeed 
      SpeedY.f = Cos(Angle*(3.14/180))*Bulletspeed 
      Addbullet(400,300,SpeedX,SpeedY) 
      Angle.f = GetMouseAngle()+350 
      SpeedX.f = Sin(Angle*(3.14/180))*Bulletspeed 
      SpeedY.f = Cos(Angle*(3.14/180))*Bulletspeed 
      Addbullet(400,300,SpeedX,SpeedY) 
      beep_(500,1) 
    EndIf 
  EndIf 
  
  FlipBuffers() 
ForEver
; ExecutableFormat=
; EOF