; English forum: 
; Author: 
; Date: 

#background = $602020

Procedure MyWindowCallBack(WindowID.l, Message.l, wParam.l, lParam.l)
Result.l
  Result = #PB_ProcessPureBasicEvents
  Select Message
    Case #WM_PAINT
      StartDrawing(WindowOutput())
        DrawImage(UseImage(0), 0, 0)
      StopDrawing()
    Case #PB_EventRepaint
      StartDrawing(WindowOutput())
        DrawImage(UseImage(0), 0, 0)
      StopDrawing()
    Case #PB_EventMoveWindow
      StartDrawing(WindowOutput())
        DrawImage(UseImage(0), 0, 0)
      StopDrawing()
    Default
  EndSelect
  ProcedureReturn Result  
EndProcedure

;
; Main starts here
;

  Quit.l = #FALSE
  Over.l = #FALSE
  WindowXSize.l = 320
  WindowYSize.l = 240

  hWnd.l = OpenWindow(0, 200, 200, WindowXSize, WindowYSize, #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_TitleBar, "MyWindow")
  If hWnd
      AddKeyboardShortcut(0, #PB_Shortcut_Escape, 99)
      
      LoadFont(0, "Verdana", 12)
      FontID.l = FontID()
      
      If CreateGadgetList(WindowID())
          SetGadgetFont(FontID,#PB_Default)
      EndIf
      
      SetWindowCallback(@MyWindowCallBack())
      
      If CreateImage(0, WindowXSize, WindowYSize)
          ImageID.l = ImageID()
          StartDrawing(ImageOutput())
            Box(0, 0, WindowXSize, WindowYSize, #background)
            For i.l = 1 To 1000
              Plot(Random(WindowXSize), Random(WindowYSize), RGB(Random(256), Random(256), Random(256)))
            Next
            DrawingFont(FontID) : FrontColor(255, 255, 0) : DrawingMode(1) : Locate(WindowXSize / 2, WindowYSize / 2) : DrawText("Hello world")
            TextLength.l = TextLength("Hello world")
          StopDrawing()
      EndIf
      
      StartDrawing(WindowOutput())
        DrawImage(ImageID, 0, 0)
      StopDrawing()
      
      x1.l = WindowXSize / 2
      x2.l = WindowXSize / 2 + TextLength
      y1.l = WindowYSize / 2
      y2.l = WindowYSize / 2 + 20
      
      Repeat
        WMX.l = WindowMouseX()
        WMY.l = WindowMouseY() - 20
          If WMX > x1 And WMX < x2 And WMY > y1 And WMY < y2 And Over = #FALSE
              Over = #TRUE
              StartDrawing(WindowOutput())
                DrawingFont(FontID) : FrontColor(255, 0, 0) : DrawingMode(1) : Locate(WindowXSize / 2, WindowYSize / 2) : DrawText("Hello world")
              StopDrawing()
            ElseIf Over = #TRUE
              Over = #FALSE
              StartDrawing(WindowOutput())
                DrawingFont(FontID) : FrontColor(255, 255, 0) : DrawingMode(1) : Locate(WindowXSize / 2, WindowYSize / 2) : DrawText("Hello world")
              StopDrawing()
          EndIf
        Select WaitWindowEvent()
          Case #PB_EventCloseWindow
            Quit = #TRUE
          Case #PB_EventMenu
            Select EventMenuID()
              Case 99
                Quit = #TRUE
            EndSelect
          Case #WM_LBUTTONDOWN
            StartDrawing(WindowOutput())
              DrawingMode(4)
              Box(x1, y1, x2-x1, y2-y1)
            StopDrawing()
            If WMX > x1 And WMX < x2 And WMY > y1 And WMY < y2
                ReleaseCapture_()
                SendMessage_(hWnd, #WM_NCLBUTTONDOWN, #HTCAPTION, 0)
            EndIf
        EndSelect
      Until Quit
      
  EndIf

End
; ExecutableFormat=Windows
; EOF