; German forum: http://robsite.de/php/pureboard/viewtopic.php?t=3235&highlight=
; Author: Danilo
; Date: 28. December 2003

; GetAsyncKeyState_() gibt ein Word zurck. Beim umwandeln des Words in ein Long
; werden alle Bits des oberen Word auf 1 gesetzt, wenn das Vorzeichenbit des
; unteren Words 1 war.

; Das niederwertigste Bit ($1) zeigt an ob die Taste nach dem letzten Aufruf von
; GetAsyncKeyState_() gedrckt wurde, und das hchstwertige Bit des Words
; ($80000000) gibt an ob die Taste gerade *jetzt* gedrckt ist.

; Du kannst also verschiedene Checks machen:

If OpenWindow(0,200,200,450,200,#PB_Window_SystemMenu,"Test of the Shift key...")
  Repeat
    Sleep_(1) : ev=WindowEvent() ; Don't use WaitWindowEvent or we won't see the keypress.
    
    ; Here follow the different possibilities to check a key...
    If GetAsyncKeyState_(#VK_SHIFT) & $1
      ; Taste wurde seit dem letzten Aufruf
      ; von GetAsyncKeyState_() gedrckt
    EndIf
    
    If GetAsyncKeyState_(#VK_SHIFT) & $80000000
      ; Taste ist JETZT gerade gedrckt
    EndIf
    
    If GetAsyncKeyState_(#VK_SHIFT) & $80000001
      ; Taste ist JETZT gerade gedrckt
      ; ODER
      ; wurde seit dem letzten Aufruf von
      ; GetAsyncKeyState_() gedrckt
    EndIf
    
    If GetAsyncKeyState_(#VK_SHIFT) = -32767 ; $FFFFFFFF80000001
      ; Taste ist JETZT gerade gedrckt
      ; ODER
      ; wurde seit dem letzten Aufruf von
      ; GetAsyncKeyState_() gedrckt
    EndIf
    
  Until ev=#PB_EventCloseWindow
EndIf
; ExecutableFormat=Windows
; FirstLine=1
; EOF