; English forum: http://purebasic.myforums.net/viewtopic.php?p=29273#29273
; Author: midebor
; Date: 29. June 2003
; 
; ------------------------------------------------------------ 
; Purebasic Webcam viewer by midebor (mdb@skynet.be) 

; The programm uses URLDownloadToFile Api to download Webcam images 
; to temp.jpg file and displays them using the UseJPEGImageDecoder() 
; function. 
; The program assumes you are already connected to the Internet 
; Has only been tested with ADSL connection 

; The program takes the Webcam's URL as program parameter. 
; Place as many instances you need on your desktop with the webcam's URL 
; you want to monitor. Only jpg format is supported 
; ------------------------------------------------------------ 
; 

UseJPEGImageDecoder() 
Parameter$ = ProgramParameter() 
If URLDownloadToFile_(0, Parameter$, "temp.jpg", 0, 0) 
EndIf 
  If LoadImage(0, "temp.jpg") 
  
    OpenWindow(0, 0, 0, ImageWidth(), ImageHeight(), #PB_Window_SystemMenu, "PureBasic - Webcam Viewer") 
    CreateGadgetList(WindowID()) 
    ImageGadget(0, 0, 0, ImageWidth(), ImageHeight(), UseImage(0), #PB_Image_Border) 
      
    Repeat 
    Until WaitWindowEvent() = #PB_EventCloseWindow 
  Else 
    MessageRequester("Error", "Can't load the image...", 0) 
  EndIf 
End 

; ExecutableFormat=Windows
; FirstLine=1
; EnableXP
; DisableDebugger
; EOF