; English forum:
; Author: PB
; Date: 19. January 2003
; OS: Windows
; Demo: No


; PureBasic has MenuHeight(), but no MenuWidth(), so here's my own!


; MenuWidth() procedure by PB -- do whatever you want with it. :)
; This example demonstrates a window having the width of its menu.
; (It's not exactly the menu width, due to Windows OS limitations).
;
Procedure MenuWidth()
  MyMenu=GetMenu_(WindowID()) : ItemSize.RECT
  For ItemNum=0 To GetMenuItemCount_(MyMenu)-1
    GetMenuItemRect_(WindowID(),MyMenu,ItemNum,ItemSize)
    width+(ItemSize\right-ItemSize\left)
  Next
  ProcedureReturn width+GetSystemMetrics_(#SM_CYHSCROLL)
EndProcedure
;
If OpenWindow(0,100,200,0,GetSystemMetrics_(#SM_CYCAPTION),#WS_VISIBLE|#PB_Window_SystemMenu,"test") And CreateMenu(0,WindowID())
  MenuItem(0,"#1") : MenuItem(0,"No. Two") : MenuItem(0,"Number Three") : MenuItem(0,"IV")
  ResizeWindow(MenuWidth(),MenuHeight()) : ShowWindow_(WindowID(),#SW_SHOW)
  Repeat : Until WaitWindowEvent()=#PB_Event_CloseWindow
EndIf
; ExecutableFormat=Windows
; FirstLine=1
; EOF