; English forum: http://purebasic.myforums.net/viewtopic.php?t=6860&highlight=
; Author: Num3 (updated for PB3.93 by Andre)
; Date: 09. July 2003
; OS: Windows
; Demo: No


; Installer.exe code, which is thought for including in the Installer-Tool.pb code later
; Need a "Pback.png" image a 480 x 50 pixels png image 


; The SFX Module code (compile it has installer.exe)

; *********** SFX MODULE ********** 
; 
;           Num3 - 2003 
; 
; Please feel free to use this code 
; 
; ********************************* 

Declare install() 
Declare unpack() 
Declare Open_Window_0() 

#Window_0  = 0 
#Gadget_0  = 0 
#Gadget_2  = 1 
#Gadget_3  = 2 
#Gadget_4  = 3 
#Gadget_5  = 4 
#Gadget_6  = 5 
#Gadget_9  = 6 

#BS_FLAT  = $8000 
#PBM_SETBARCOLOR  = $409 
#PBM_SETBKCOLOR  = $2001 

;- Image Plugins 
UsePNGImageDecoder() 

;- Image Globals 
Global Image0 

;- Catch Images 
Image0  = CatchImage(0, ?Image0) 

;- Images 

DataSection 
Image0 : 
IncludeBinary "Pback.png" ; ***** 480 x 50 pixels png image 
EndDataSection 

Procedure Open_Window_0() 
  If OpenWindow(#Window_0, 263, 244, 458, 187, #PB_Window_SystemMenu  | #PB_Window_TitleBar , "PureBasic Tools Installer") 
    If CreateGadgetList(WindowID()) 
      Frame3DGadget(#Gadget_0,   - 5, 135, 470, 105, "") 
      TextGadget(#Gadget_2,  15, 70, 225, 20, "Please select a directory to install") 
      StringGadget(#Gadget_3,  15, 90, 365, 20, "") 
      ButtonGadget(#Gadget_4,  385, 90, 60, 20, "Browse", #BS_FLAT) 
      ButtonGadget(#Gadget_5,  360, 155, 75, 20, "Install", #BS_FLAT) 
      ImageGadget(#Gadget_9,   - 15,  - 5, 480, 50, Image0) 
      
    EndIf 
  EndIf 
EndProcedure 

Structure stuff 
  dir.s 
  file.s 
  args.s 
  name.s 
  help.s 
  run.b 
  wait.b 
  hide.b 
  reload.b 
EndStructure 


Global path.s, windir.s, save.stuff, filename.s 

filename.s  = Space(1000) 
GetModuleFileName_(0,  filename.s, 1000) 
filename  = GetFilePart(filename) 

; **** Get PureBasic Default Dir **** 

path  = "Applications\PureBasic.exe\shell\open\command" 
If RegOpenKeyEx_(#HKEY_CLASSES_ROOT, path, 0, #KEY_ALL_ACCESS, @Key) = #ERROR_SUCCESS 
  indir.s  = Space(500) 
  insize  = 500 
  If RegQueryValueEx_(Key, "", 0, 0, @indir.s, @insize) = #ERROR_SUCCESS 
    RegCloseKey_(Key) 
    indir  = RemoveString(indir, "%1", 1) 
    indir  = RemoveString(indir, Chr(34), 1) 
    indir  = RTrim(indir) 
    path  = GetPathPart(indir) 
  Else 
    MessageRequester("Installer Error!",  "Hum... Seems i can't find Purebasic", #MB_ICONERROR) 
    RegCloseKey_(Key) 
    path  = "C:\purebasic" 
  EndIf 
EndIf 


; **** Get windows temp Dir **** 

windir.s  = Space(255) 
If GetTempPath_(255, windir) 
Else 
  windir  = "c:\" 
EndIf 


Open_Window_0() 
unpack() 

Repeat 
  
  Event  = WaitWindowEvent() 
  
  If Event  = #PB_EventGadget 
    
    GadgetID  = EventGadgetID() 
    
    If GadgetID  = #Gadget_5 
      ;- Unpack 
      install() 
    ElseIf GadgetID  = #Gadget_4 
      x.s  = PathRequester("Please Select Destination", path) 
      If x  <  > "" 
        x  = ReplaceString(x, "\", "" , 0, Len(x)-2) 
        SetGadgetText(#gadget_3,  x) 
      EndIf 
    EndIf 
    
  EndIf 
  
Until Event  = #PB_EventCloseWindow 

DeleteFile(windir  + "\"  + save\file) 
DeleteFile(windir  + "\"  + save\help) 
DeleteFile(windir  + "\pbti.txt") 

Procedure unpack() 
  
  If ReadFile(0, filename) 
    
    
    FileSeek(Lof()-4) 
    filelen.l  = ReadLong() 
    
    
    *mem = AllocateMemory(filelen) 
    FileSeek(Lof()-4  - filelen) 
    ReadData(*mem,  filelen) 
    
    
    CreateFile(1,  windir  + "\tmp.pak") 
    WriteData(*mem,  filelen) 
    CloseFile(1) 
    CloseFile(0) 
  Else 
    MessageRequester("Installer Error!",  "Hum... Seems there is no package to deliver !", #MB_ICONERROR) 
    
  EndIf 
  
  
  If OpenPack(windir  + "\tmp.pak") 
    *file  = NextPackFile() 
    size.l  = PackFileSize() 
    CreateFile(0,  windir  + "\pbti.txt") 
    WriteData(*file , size) 
    CloseFile(0) 
    
    If OpenPreferences(windir  + "\pbti.txt") 
      
      save\dir  = ReadPreferenceString("Dir", "") 
      save\file  = ReadPreferenceString("File", "") 
      save\args  = ReadPreferenceString("Args", "") 
      save\name  = ReadPreferenceString("Name", "") 
      save\help  = ReadPreferenceString("Help", "") 
      save\run  = Val(ReadPreferenceString("Run", "")) 
      save\wait  = Val(ReadPreferenceString("Wait", "")) 
      save\hide  = Val(ReadPreferenceString("Hide", "")) 
      save\reload  = Val(ReadPreferenceString("Reload", "")) 
      
      ClosePreferences() 
      
    EndIf 
    
    SetGadgetText(#gadget_3,  path  + save\dir) 
    
    *file  = NextPackFile() 
    size.l  = PackFileSize() 
    CreateFile(0,  windir  + "\"  + save\file) 
    WriteData(*file , size) 
    CloseFile(0) 
    
    If save\help  <  > "" 
      *file  = NextPackFile() 
      size.l  = PackFileSize() 
      CreateFile(0,  windir  + "\"  + save\help) 
      WriteData(*file , size) 
      CloseFile(0) 
    EndIf 
    
    ClosePack() 
    
    DeleteFile(windir  + "\tmp.pak") 
  EndIf 
  
  
EndProcedure 

Procedure install() 
  
  CreateDirectory(GetGadgetText(#gadget_3)) 
  
  in.s  = windir  + "\"  + save\file 
  out.s  = GetGadgetText(#gadget_3)+"\"  + save\file 
  If CopyFile(in, out) 
  EndIf 
  
  If save\help  <  > "" 
    in.s  = windir  + "\"  + save\help 
    out.s  = GetGadgetText(#gadget_3)+"\"  + save\help 
    If CopyFile(in, out) 
    EndIf 
  EndIf 
  
  
  If OpenFile(0, path  + "tools.prefs") 
    
    While Eof(0)=0 
      x.s  = ReadString() 
      w  = FindString(x, "ToolCount = ", 1) 
      
      If w 
        
        count  = Val(Mid(x, 12 , Len(x))) 
        count  + 1 
        FileSeek(Loc()-Len(x)-2) 
        WriteStringN("ToolCount = "  + Str(count)) 
        
      EndIf 
    Wend 
    FileSeek(Lof()) 
    WriteStringN(";") 
    WriteStringN(";") 
    WriteStringN("[Tool_"  + Str(count)+"]") 
    WriteStringN("Command = "  + GetGadgetText(#gadget_3)+"\"  + save\file) 
    WriteStringN("Arguments = "  + save\args) 
    WriteStringN("WorkingDir = ") 
    WriteStringN("MenuItemName = "  + save\name) 
    WriteStringN("Shortcut = " ) 
    WriteStringN("Flags = "  + Str(save\wait)) 
    WriteStringN("ReloadSource = "  + Str(save\reload)) 
    WriteStringN("HideEditor = "  + Str(save\hide)) 
    
    CloseFile(0) 
    
  EndIf 
  
  
  DeleteFile(windir  + "\"  + save\file) 
  DeleteFile(windir  + "\"  + save\help) 
  DeleteFile(windir  + "\pbti.txt") 
  
  MessageRequester("Installer",  "Installation Complete!", #MB_ICONINFORMATION ) 
  End 
  
EndProcedure 


End 
 

; ExecutableFormat=Windows
; FirstLine=1
; EOF